var toolbox     = require('@spark-engine/toolbox'),
    Event       = require('@spark-engine/event'),
    tree        = require('./_tree')

function matchUrl(url, link) {
  var linkUrl = new URL(link.href).pathname

  return linkUrl == url
}

function setInactive(el) {
  el.classList.remove('active')
  tree.setInactive(el)
}

function setActive(el) {
  el.classList.add('active')
  tree.setActive(el)
}

function toggleActive(url) {
  url = new URL(url).pathname

  // Find all active links which are not on-page anchors
  toolbox.each(document.querySelectorAll('nav .active[href]:not([href^="#"])'), function(link) {
    // If they don't point to the URL, deactivate them
    if (!matchUrl(url, link)) { setInactive(link) }
  })

  // Activate all inactive links which match the URL
  toolbox.each(document.querySelectorAll('nav [href="'+url+'"]:not(.active)'), setActive)
}

Event.beforeChange(function(event) {
  if (event.data && event.data.url) { toggleActive(event.data.url) }
})
