var Event      = require('@spark-engine/event'),
    toolbox    = require('@spark-engine/toolbox'),
    setText    = require('../../form/_set-text'),
    tabRoot    = '.spark-nav-tabs',
    tabGroup   = '.spark-nav-group'

function setup() {
  Event.change(function() {
    toolbox.each(document.querySelectorAll(tabRoot + ':not([data-collapse-at]) ' + tabGroup), function(group) {
      var size = 0
      var root = group.closest(tabRoot)

      toolbox.each(group.children, function(tab){ size += tab.clientWidth })
      root.dataset.collapseAt = size
      toggleTabCollapse(root)
    })

    toolbox.each(document.querySelectorAll('[role=tab][aria-selected=true]'), function(tab) {
      tab.classList.add('active')
    })
    // Ensure that active tabs set their nav-toggler label on page changes.
    toolbox.each(document.querySelectorAll('[role=tab].active[data-set-text]'), function(tab) {
      setText.trigger(tab) })
  })

  Event.resize(resize)
}

function resize() {
  toolbox.each(document.querySelectorAll(tabRoot + '[data-collapse-at]'), toggleTabCollapse)
}

function toggleTabCollapse(el) {
  el.dataset.collapse = el.clientWidth <= el.dataset.collapseAt
}

module.exports = { setup: setup }
