var Event = require('@spark-engine/event')

Event.ready(function() {

  // Toggle value state classes on search inputs
  // Enable and disable clear button based on input value
  Event.on(document, 'input', '[role=search]', Event.debounce(function (event) {

    var input = event.currentTarget,
        label = input.closest('.text-input-label')

    input.classList.toggle('input-filled', input.value != '')
    input.classList.toggle('input-empty', input.value == '')

    if (label) {
      label.classList.toggle('input-filled', input.value != '')
      label.classList.toggle('input-empty', input.value == '')

      // If input value is '', hide "clear search button"
      var clearBtn = label.querySelector('.clear-search')
      if (clearBtn) clearBtn.disabled = input.value == ''

    }

  }))

  // Focus on the input after the click occurs
  Event.on(document, 'click', '.clear-search', function(){
    var label = event.target.closest('.text-input-label')
    if (label) {
      input = label.querySelector('[role=search]')
      if (input) input.focus
    }
  }, { useCapture: true })
})
