// Make it easy to set input values from a DOM element
// 'click' on elements data-set-input='.input-1:value,.input-2:value2'
//                     data-clear-input='.input-1'
//

var toolbox = require('@spark-engine/toolbox')
var Event   = require('@spark-engine/event')

function watch() {
  Event.on(document, 'click', '[data-set-input],[data-clear-input]', click, { useCapture: true })
}

function click(event) {

  event.preventDefault()
  var el = event.currentTarget

  // Find element selectors from data property
  if (el.dataset.clearInput) {
    toolbox.each(event.currentTarget.dataset.clearInput.split(','), function(selector) {
      setValue(selector, '')
    })
  }

  // Find element selectors an new value from data property
  if (el.dataset.setInput) {
    toolbox.each(event.currentTarget.dataset.setInput.split(','), function(data) {
      setValue.apply(null, data.split(':'))
    })
  }
}

function setValue(input, value) {

  if (typeof value == 'undefined') value = ''
  var el = document.querySelector(input)

  if (el) { 
    el.value = value 
    Event.fire(el, 'input')
  }
}

Event.ready(watch)
