// Make it easy to set text content of another elemnet
//  options: 
//   - data-set-text='#selected-element:text-content' - Set the innerHTMl of #selected-element to "text-content"
//   - data-set-text='#selected-element' - Set the innerHTMl of #selected-element to the textContent of the triggering element
//

var toolbox = require('@spark-engine/toolbox')
var Event   = require('@spark-engine/event')

function watch() {
  Event.on(document, 'click', '[data-set-text]', click, { useCapture: true })
}

function click(event) {
  triggerSetText(event.currentTarget)
}

function triggerSetText(el) {
  // Find element selectors an new value from data property
  toolbox.each(el.dataset.setText.split(','), function(data) {
    setText.apply(null, determineText(el, data))
  })
}

function determineText(el, data) {
  var parameters = data.split(':')
  parameters[1] = parameters[1] || el.textContent()
  return parameters
}

function setText(target, text) {
  var el = document.querySelector(target)
  if (el) { el.innerHTML = text }
}

Event.ready(watch)

module.exports = {
  trigger: triggerSetText
}
