// Allows a separate element to represent a <select> for visual freedom.
// Changes to <select data-sync-selected='.selector'> will select elements and set content with the content of the selected option.

var toolbox = require('@spark-engine/toolbox')
var Event = require('@spark-engine/event')

function sync(event) {
  var select = event.currentTarget,
      els    = document.querySelectorAll(select.dataset.syncSelected)

  toolbox.each(els, function(el) {
    el.innerHTML = select.options[select.selectedIndex].text
  })
}

Event.ready(function(){
  Event.on(document, 'input change', 'select[data-sync-selected]', sync)
}, { useCapture: true })
