// When scrollbars are always visible this will missalign fixed width absolutely positioned elements
// Elements may use `data-match-width=".selector"` to match the width of another element, solving
// scrollbar misalignment

var toolbox = require('@spark-engine/toolbox'),
    Event   = require('@spark-engine/event')

function setMatchWidth() {
    toolbox.each(document.querySelectorAll('[data-match-width]'), function(el) {
      var widthEl = document.querySelector(el.dataset.matchWidth)
      if (widthEl) el.style.width = widthEl.clientWidth + 'px'
    })
}

// On DOM ready and page transitions (i.e., turbolinks) subtract scroll widths.
Event.ready(setMatchWidth)
