require('./shims/_dataset')
require('./shims/_scroll-detect')

// Require modules, add code, etc
var Event     = require('@spark-engine/event'),
    toggler   = require('@spark-engine/toggler'),
    toolbox   = require('@spark-engine/toolbox')

var autoGrid  = require('./components/layout/_auto-grid'),
    cookie    = require('./_cookie'),
    copy      = require('./components/ui/_copy'),
    esvg      = require('./_esvg'),
    menu      = require('./_menu'),
    modal     = require('./_modal'),
    navToggle = require('./components/nav/_toggle')
    search    = require('./_search'),
    stack     = require('./_stack'),
    sticky    = require('./components/ui/_sticky_panel'),
    tabs      = require('./components/nav/_tabs'),
    toast     = require('./components/ui/_toast'),
    tree      = require('./components/nav/_tree')

require('./_icons')
require('./components/app/sidebar/_fix')
require('./components/app/sidebar/_toggle')
require('./components/nav/_link-state')
require('./form/_input-status')
require('./form/_set-input')
require('./form/_set-text')
require('./form/_sync-select')

autoGrid.setup()
copy.setup()
menu.setup()
modal.setup()
navToggle.setup()
search.setup()
stack.setup()
sticky.setup()
tabs.setup()
tree.setup()

// Simple ignore click on anchor triggers
Event.on(document, 'click', '[href="#"]', function(event) {
  event.preventDefault()
})

window.spark = module.exports = toolbox.merge({
  autoGrid: autoGrid,
  cookie: cookie,
  esvg: esvg,
  event: Event,
  modal: modal,
  stack: stack,
  sticky: sticky,
  toast: toast,
  toggler: toggler
}, toolbox)
