module Spark
  class Badge < Spark::Component::Base
    COLOR = %i[red yellow green teal blue purple gray].freeze
    THEME = %i[fill outline]
    attribute :text, theme: :fill, color: :gray

    validates_attr :text, presence: true
    validates_attr :color, choices: COLOR
    validates_attr :theme, choices: THEME

    def initialize(*)
      super

      classname.add("spark-badge")
    end
  end
end
