module Spark
  class Banner < Spark::Component::Base
    THEME = %i[message alert warning admin].freeze

    attribute :message, :href, :target
    attribute action_text: "Learn more", theme: "message"

    validates_attr :theme, choices: THEME

    def initialize(*)
      super

      tag_attrs.add(role: "banner")
      classname.add("app-banner", "theme-#{@theme}")
    end

    def to_partial_path
    end

    def theme_icon
      case @theme.to_sym
      when :message then "message-text"
      when :alert then "message-alert"
      when :warning then "message-alert"
      when :admin then "admin-user"
      end
    end
  end
end
