module Spark
  class Button
    class Group < Spark::Component::Base

      COLORS = Spark::Button::COLORS
      SIZES = Spark::Button::SIZES
      STYLES = Spark::Button::STYLES

      attribute :color, :size, :style, role: "group"

      validates_attr :color, choices: COLORS, allow_nil: true
      validates_attr :size, choices: SIZES, allow_nil: true

      element :button, multiple: true, component: Spark::Button
      element :menu_button, multiple: true, component: Spark::MenuButton do
        def initialize(*)
          super
          _parent.buttons << self
        end
      end

      def initialize(*)
        super

        classname.base = "spark-button-group"
        set_element_attribute_default(:button, color: @color, size: @size, style: @style)
        set_element_attribute_default(:menu_button, color: @color, size: @size, style: @style)
      end
    end
  end
end
