module Spark
  class Card < Spark::Component::Base
    LAYOUT = %i[flush padded].freeze
    ALIGN = %i[left center right split].freeze

    element :header, component: Spark::Block do
      attribute layout: :padded
    end

    element :body, multiple: true do
      data_attribute :align, layout: :padded

      validates_attr :layout, choices: LAYOUT
      validates_attr :align, choices: ALIGN, allow_nil: true
    end

    element :footer do
      data_attribute :align, layout: :padded

      validates_attr :layout, choices: LAYOUT
      validates_attr :align, choices: ALIGN, allow_nil: true
    end

    def initialize(*)
      super
      classname.add("spark-card")
    end
  end
end
