module Spark
  class Checklist
    class Item < Spark::Component::Base
      attribute :href, :target, :icon, :action_text, :text, completed: false

      validates_attr :href, presence: true
      validates_attr :action_text, presence: true
      validates_attr :text, presence: true
      validates_attr :completed, inclusion: [true, false]

      def initialize(*)
        super

        classname.base = 'spark-checklist-item'
        tag_attrs.add(rel: 'noopener noreferrer') if @target == "_blank"
      end

      def complete_class
        'complete' if @completed
      end
    end
  end
end
