module Spark
  module Component
    class Base < ActionView::Component::Base
      include Spark::Component

      def selector(root, sub = nil, val: nil)
        sub = sub.to_s.dasherize if sub
        val ||= case root
        when :data, :aria then
          tag_attrs[root][sub]
        else
          tag_attrs[root]
        end

        %([#{[root, sub].compact.join('-').dasherize}="#{val}"])
      end

      def unique_id(prefix = :id)
        "#{prefix}-#{SecureRandom.hex(10)}"
      end

      def to_s
        self.yield
      end
    end
  end
end
