module Spark
  module Embed
    class WistiaMedia < Spark::Component::Base
      attribute :video_id, :background_image_url, :title, :subtitle, :height, :width

      validates_attr :video_id, presence: true
      validates_attr :background_image_url, presence: true
      validates_attr :height, presence: true, numericality: { only_integer: true }
      validates_attr :width, numericality: { only_integer: true }, allow_blank: true

      def initialize(*)
        super

        classname.base = "spark-wistia-media"

        unless @height.blank?
          tag_attrs.merge!(style: "height: #{@height}px;max-width: #{@width}px")
        end
      end
    end
  end
end
