module Spark
  class Icon < ActionView::Component::Base
    include Spark::Component

    SIZE = { xsmall: 10, small: 14, base: 16, text: "1em", medium: 18, large: 24, xlarge: 32 }

    attribute :name, :width, :height, size: :base

    validates_attr :size, choices: SIZE.keys

    def initialize(*)
      super

      raise no_icon_found if !Rails.env.production? && !Esvg.find_symbol(@name)
      tag_attrs.add width: icon_width, height: icon_height, content: @yield

      classname.base = "spark-icon"
    end

    private

    def no_icon_found
      %(Cannot find icon "#{@name}". A list of available icons can be found at http://spark.fleetio.com/resources/icons)
    end

    def icon_width
      @width || @height || SIZE[@size]
    end

    def icon_height
      @height || @width || SIZE[@size]
    end
  end
end
