module Spark
  module Input
    class Base < Spark::Component::Base
      attribute :value, :disabled, :required, :name, :label

      # If a label is not passed, require an aria-label for accessibility
      validates_attr :label, presence: { message: %q(A label or `aria: { label: "text" }` is required for accessiblity.) }, unless: -> { @aria.present? && @aria[:label].present? }

      def initialize(*)
        super

        tag_attrs.add attr_hash(:value, :disabled, :required, :name)
        classname.add "spark-input"
      end
    end
  end
end
