module Spark
  module Input
    class Switch < Spark::Input::Checkbox
      SIZE      = %i[small medium].freeze
      ALIGNMENT = %i[left right].freeze

      attribute size: :medium, align: :left, value: :true

      validates_attr :size, choices: SIZE
      validates_attr :align, choices: ALIGNMENT

      def initialize(*)
        super

        switch_class.add("size-#{@size}")
        switch_class.add("align-#{@align}") if @align
      end

      def switch_class
        @switch_class ||= Classname.new(base: "spark-input-switch")
      end
    end
  end
end
