module Spark
  class MediaBlock < Spark::Component::Base
    LAYOUT = %i[default reverse]
    ALIGN = %i[top middle bottom]
    GUTTER = %i[small base medium large xl].freeze

    attribute :align, :gutter, :expand, layout: :default

    element :image
    element :title
    element :body

    validates_attr :layout, choices: LAYOUT
    validates_attr :align, choices: ALIGN, allow_nil: true
    validates_attr :gutter, choices: GUTTER, allow_nil: true

    def initialize(*)
      super

      classname.add("spark-media-block")
      classname.add("layout-#{@layout}") if @layout
      classname.add("align-#{@align}") if @align
      classname.add("gutter-#{@gutter}") if @gutter
      classname.add("expand") if @expand
    end
  end
end
