module Spark
  module Nav
    class Group < Spark::Component::Base
      attribute role: 'group', item_role: 'menuitem'

      element :item, multiple: true, component: Spark::Nav::Item

      def initialize(*)
        super

        classname.add("active") if active?
      end

      def new?
        items.any?(&:new?)
      end

      def beta?
        items.any?(&:beta?)
      end

      def active_item
        items.find(&:active?)
      end

      def active?
        items.any?(&:active?)
      end
    end
  end
end
