module Spark
  module Nav
    class Item < Spark::Component::Base
      attribute :text, :icon, :detail, :badge, :active, :beta, :new, :href, :role, :id, :tabindex, :target, icon_size: :small

      validates_attr :text, presence: true, if: -> { text.blank? }

      element :icon
      element :text

      def initialize(*)
        super

        @href = @href || "#"
        tag_attrs.add attr_hash(:target, :tabindex, :role)
        classname.base = "nav-item"
        classname.add(:active) if active?
      end

      def label
        if new?
          "new"
        elsif @beta
          "beta"
        end
      end

      def new?
        if @new.is_a?(String)
          30.days.ago <= Time.zone.parse( @new )
        else
          @new
        end
      end

      def active?
        @href != "#" && @active || @view_context && @view_context.current_page?(@href)
      end
    end
  end
end
