module Spark
  module Nav
    class TabPanels < Nav::Tabs
      element :item, multiple: true, component: Spark::Nav::Item do
        element :panel

        def initialize(*)
          super

          tag_attrs.add(role: :tab, id: "tab-#{tab_id}")
          data.add(anchor: @href, add_class: :active)
          aria.add(controls: "panel-#{tab_id}", selected: !!@active)

          # Set to active if this is the first tab
          classname.add(:active) if _parent.items.empty?
        end

        def tab_id
          @tab_id ||= unique_id
        end

        private
      end

      def initialize(*)
        super
        @nav_group_attrs.add(role: "tablist")
      end

      def active_item_text
        items.first.attribute(:text)
      end

      private

      def item_group(options={}, &block)
        options.merge!({ role: "tablist" })
        super(options, &block)
      end
    end
  end
end
