module Spark
  module Nav
    class Tabs < Spark::Component::Base
      LAYOUT = %i[flush padded]
      THEME = %i[tabs pills]

      attribute :label, role: "navigation", layout: :flush
      attribute theme: :tabs

      validates_attr :label, presence: true
      validates_attr :layout, choices: LAYOUT
      validates_attr :theme, choices: THEME

      element :item, multiple: true, component: Spark::Nav::Item do
        validates_attr :text, presence: true
      end

      def initialize(*)
        super

        classname.base = "spark-nav-#{@theme}"
        classname.add %(layout-#{@layout})
        data.add nav_id: unique_id
        @nav_group_attrs = TagAttr.new
      end

      private

      def active_item_text
        if active_item = items.find(&:active?)
          active_item.attribute(:text)
        else
          "Menu"
        end
      end
    end
  end
end
