module Spark
  module Nav
    class Toggle < Spark::Component::Base

      attribute :target, :text, :id, :menu_icon, icon: 'chevron-down', type: :button
      validates_attr :target, presence: true

      def initialize(*)
        super

        tag_attrs.add id: (@id || unique_id)
        aria.add(hidden: true)
        # When toggled on, adds an active class to itself and `nav-active` to `target` selector.
        data.add(nav_toggle: @target)

        classname.base = "nav-toggle"
      end
    end
  end
end
