module Spark
  module Nav
    class Tree
      class Group < Spark::Nav::Group
        attribute :icon, :title, :icon_size, expanded: false

        validates_attr :title, presence: true

        def initialize(*)
          super

          classname.base = "nav-item-wrapper"
          tag_attrs.add(role: :treeitem)
        end

        def node
          @title.to_s.strip.downcase.gsub(/[\W,-]+/, '_')
        end

        def expanded?
          @expanded || active?
        end
      end
    end
  end
end
