module Spark
  class Table
    class Cell < Spark::Component::Base
      SCOPE  = %i[col row colgroup rowgroup]
      SIZES  = %i[xs small base medium large xl max]

      attribute :rowlink_skip, :nowrap, :fit
      tag_attribute :scope
      data_attribute :align, :v_align, :size

      attribute_default_group(fit: {
        true: {
          nowrap: true,
          size: :xs
        }
      })

      validates_attr :scope, choices: SCOPE, allow_nil: true
      validates_attr :align, choices: Spark::Table::Row::ALIGN, allow_nil: true
      validates_attr :v_align, choices: Spark::Table::Row::VALIGN, allow_nil: true
      validates_attr :size, choices: SIZES, allow_nil: true

      def initialize(*)
        super
        classname.add("nowrap") if @nowrap
        classname.add("rowlink-skip") if @rowlink_skip
      end
    end
  end
end
