module Spark
  class Table
    class Object < Spark::Component::Base
      attribute :title

      # Require attribute title unless title element was passed
      validates_attr :title, presence: true, unless: -> { title.present? }

      element :title
      element :value

      def initialize(*)
        super
      end

      def title_attrs
        obj = title.present? ? title.tag_attrs : TagAttr.new
        obj.add scope: :row
        obj.classname.add "spark-table-detail-title"
      end

      def value_attrs
        obj = value.present? ? value.tag_attrs : TagAttr.new
        obj.classname.add "spark-table-detail-value"
        obj
      end
    end
  end
end
