module Spark
  class Table
    class Row < Spark::Component::Base
      ALIGN  = %i[left center right]
      VALIGN = %i[top middle bottom]

      attribute :align, :v_align, :nowrap

      validates_attr :align, choices: ALIGN, allow_nil: true
      validates_attr :v_align, choices: VALIGN, allow_nil: true

      element :td, multiple: true, component: Spark::Table::Cell do
        def initialize(*)
          super
        end
      end

      element :th, multiple: true, component: Spark::Table::Cell do
        def initialize(*)
          super
          _parent.tds << self
        end
      end

      def initialize(*)
        super
        set_element_attribute_default(:td, align: @align, v_align: @v_align, nowrap: @nowrap)
        set_element_attribute_default(:th, align: @align, v_align: @v_align, nowrap: @nowrap)
      end
    end
  end
end
