module Spark
  class TrialNotice < Spark::Component::Base
    attribute :end_date, :href, :action_text

    validates_attr :action_text, presence: true
    validates_attr :href, presence: true
    validates_attr :end_date, presence: true

    def initialize(*)
      super

      classname.add("spark-trial-notice")

      if days < 1
        classname.add("trial-ended")
      elsif 1 <= days && days < 5
        classname.add("trial-ending-soon")
      end
    end

    def status_color
      if days < 1
        :red
      elsif 1 <= days && days < 5
        :yellow
      else
        :purple
      end
    end

    def days
      [0, (@end_date.to_date - Time.zone.now.to_date).to_i].max
    end
  end
end
