module Spark
  module ApplicationHelper

    def tree_cookie
      @_tree_cookie ||= begin
        JSON.parse(cookies[:tree_nav]) if cookies[:tree_nav].present?
      rescue
        nil
      end
    end

    def is_tree_expanded?( item )
      tree_cookie.present? && !!tree_cookie( item )
    end
    
    def ng_attrs
      attrs = {}

      [:ng_init, :ng_controller].each do |sym|
        attrs[sym] = content_for(sym) if content_for?(sym)
      end

      attrs

    end

    def yield_if(symbol, &block)
      yield content_for(symbol) if content_for?(symbol)
    end

    def body_class(classnames=nil)
      unless classnames.nil?
        content_for(:body_classes) do 
          [classnames].flatten.join(' ') + ' '
        end
      end
      if classes = content_for(:body_classes)
        classes.strip
      end
    end

    def ie_11_flex_layout_fix
      user_agent = request.env['HTTP_USER_AGENT'].downcase
      if user_agent.match(/trident/) && user_agent.match(/rv:11/)
        %(<script type="text/javascript">(function(){
          var wrapper = document.querySelector('.app-wrapper')
          wrapper.style.flexBasis = "calc(100vh - "+wrapper.offsetTop+"px)";
        })()</script>).html_safe
      end
    end
  end
end
