module Spark
  module IconHelper
    def svg_symbols(*keys)
      unless Rails.env.production?
        Esvg.embed(keys)
      end
    end

    def status_icon (status, options={})
      options[:height] ||= '1em'
      span_options = {}

      span_options['aria-label'] = status.titlecase
      span_options[:class] = 'status-icon inline-icon has-tooltip'
      options[:desc] ||= status

      content_tag :span, span_options do
        use_svg "status-#{status}", options
      end
    end

    def small_icon(name, options={})
      use_svg(name, options.merge({width: '25px'}))
    end

    def inline_icon(name, options={}, &block)
      options[:height] ||= '100%'
      options[:width]  ||= '100%'
      content_tag :span, class: 'svg-wrapper inline-icon' do
        use_svg name, options, &block
      end
    end

    def svg(name, options={}, &block)
      content_tag :span, class: 'svg-wrapper' do
        use_svg name, options, &block
      end
    end
  end
end
