module Spark
  module TagHelper 
    
    # Takes an options hash, appends classnames (array or string)
    def add_class( options, classnames )
      options = options.stringify_keys
      options['class'] = ([options['class']].flatten | [classnames].flatten).compact
      options
    end

    def select_input_tag( name, option_tags=nil, options={}, &block )
      if option_tags.is_a? Hash
        options = option_tags
        option_tags = nil
      end

      option_tags ||= capture( &block ).html_safe if block_given?

      input_tag( :select, name, option_tags, options )
    end

    def search_input_tag( name, value = nil, options = {}, &block )
      input_tag( :search, name, value, options, &block )
    end

  end
end
